<!DOCTYPE html>
<html lang="fr">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Comptage manifestants</title>
  <meta name="author" content="Aldo Gonzalez-Lorenzo">
  <style>
    #comptage canvas {
      cursor: crosshair;
    }
    .container {
      display: flex
    }
    .container p:first-child {
      width: 200px;
    }
    p {
      margin: 2px;
    }
    input[type="number"] {
      width: 3rem;
    }
    label {
      cursor: help;
    }
  </style>
  <script src="https://cdn.jsdelivr.net/npm/p5@1.1.9/lib/p5.js"></script>
</head>

<body>
  <div id="comptage"></div>
  <div class="container">
    <p>
      Time: <span id="time"></span>
    </p>  
    <p>
      <button id="rewind" title="Go back 0.5 seconds">Rewind</button>
      <button id="pause">Pause</button>
      <button id="play">Play</button>
    </p>
  </div>
  <p>
    <label title="Value between 0 and 1">
      X offset
      <input id="zoom_x" type="number" step= "0.01" value="0" min="0" max="1">
    </label>
    <label title="Value between 0 and 1">
      Y offset
      <input id="zoom_y" type="number" step= "0.01" value="0" min="0" max="1">
    </label>
    <label title="Value between 0 and 1">
      Zoom
      <input id="zoom_k" type="number" step= "0.1" value="1" min="0.1">
    </label>
    <label title="Value between 0 and 1">
      Canvas size
      <input id="zoom_cs" type="number" step= "0.1" value=".4" min="0.1">
    </label>
    <!-- <button id="zoom">Resize</button> -->
  </p>
  <p>
    Manifestants enregistrés : <span id="manifestants">0</span><br>
    <small></small> <button id="back">Going back</button><br>
    <textarea rows="2" cols="100"></textarea> <button id="import">Import</button><br>
  </p>
  <script>
    let mode = 'start'
    let people = []
    let zoom = {x: 0, y: 0, k: 1}
    let hovered_person_index

    const comptage = p => {
      /* Global variables */
      let video

      p.setup = function () {
        p.createCanvas(400, 400)

        video = p.createVideo('2023-03-07_part58.mp4', () => {
          video.volume(0)
          video.play()
          video.pause()
          p.set_canvas_size()
          video.hide() // hides the html video loader
        })
      }

      // Set the height of the video to a confortable size
      p.set_canvas_size = function () {
        const size = Number(document.querySelector('input#zoom_cs').value)
        p.resizeCanvas(size*video.width, size*video.height)
        zoom.k = size
        document.querySelector('#zoom_k').value = size
      }

      // Set the width of the video to a confortable size
      p.set_zoom = function () {
        zoom.x = Number(document.querySelector('#zoom_x').value)
        zoom.y = Number(document.querySelector('#zoom_y').value)
        zoom.k = Number(document.querySelector('#zoom_k').value)
      }


      p.draw = function () {
        p.background(240)
        let img = video.get()
        //p.image(img, 0, 0) // redraws the video frame by frame
        p.image(
          img, 
          - zoom.x*img.width*zoom.k, - zoom.y*img.height*zoom.k, img.width*zoom.k, img.height*zoom.k,
          ) // redraws the video frame by frame
        draw_people()
        document.querySelector('#time').textContent = `${p.nf(video.time(), 0, 2)} / ${video.duration()}`
      }

      draw_people = function () {
        for (let i = 0; i < people.length; i++) {
          const person = people[i]
          if (Math.abs(person.t - video.time()) < 0.5) {
            p.push()
            p.noStroke()
            p.fill('rgba(0, 255, 0, 0.5)')
            const coord = coord_to_local(person)
            if (person.back) {
              p.fill('rgba(255, 0, 0, 0.5)')
            }
            if (p.dist(p.mouseX, p.mouseY, coord.x, coord.y) < 10) {
              p.fill('rgba(0, 0, 255, 0.5)')
              set_hovered(i)
              hovered_person_index = i
              document.querySelector('small').textContent = "Hovered person: " + JSON.stringify(person)
            }
            p.circle(coord.x, coord.y, 10)
            p.pop()
          }
        }
      }

      set_hovered = function(i) {
        hovered_person_index = i
        document.querySelector('small').textContent = "Hovered person: " + JSON.stringify(people[i])
        const button = document.querySelector('#back')
        if (people[i].back) {
          button.textContent = 'Going forwards'
        } else {
          button.textContent = 'Going back'
        }
      }

      /**
       * Label the last hovered person as going back or not
       */
      p.label_back = function () {
        if (!people[hovered_person_index].back) {
          people[hovered_person_index]['back'] = true
          document.querySelector('#back').textContent = "Going forwards"
        } else {
          people[hovered_person_index]['back'] = false
          document.querySelector('#back').textContent = "Going back"
        }
        document.querySelector('textarea').value = JSON.stringify(people)
        count_manifestants()
        document.querySelector('small').textContent = "Hovered person: " + JSON.stringify(people[hovered_person_index])
      }

      coord_to_global = function(coord) {
        const x = coord.x / (zoom.k*video.width ) + zoom.x
        const y = coord.y / (zoom.k*video.height) + zoom.y
        return {x: x, y: y}
      }

      coord_to_local = function(coord) {
        const x = (coord.x - zoom.x) * video.width  * zoom.k
        const y = (coord.y - zoom.y) * video.height * zoom.k
        return {x: x, y: y}
      }

      p.mousePressed = function () {
        if (!(0 <= p.mouseX && p.mouseX <= p.width && 0 <= p.mouseY && p.mouseY <= p.height)) {
          return
        }
        const coord = coord_to_global({x: p.mouseX, y: p.mouseY})
        const person = {
          t: video.time(),
          x: coord.x,
          y: coord.y,
          back: false
        }
        people.push(person)
        count_manifestants()
        document.querySelector('textarea').value = JSON.stringify(people)
      }

      p.keyPressed = function () {
        if (p.keyCode === p.RIGHT_ARROW || p.keyCode === 69) {
          p.forward()
        } else if (p.keyCode === p.LEFT_ARROW || p.keyCode === 65) {
          p.backward()
        } else if (p.keyCode === p.DOWN_ARROW || p.keyCode === 90) {
          p.pause()
        }
      }

      p.mouseOver = function() {
        console.log(p.mouseX, p.mouseY)
      }

      p.forward = function () {
        video.play()
      }

      p.backward = function () {
        video.time(video.time() - 0.5)
      }

      p.pause = function () {
        video.pause()
      }

      p.import = function() {
        people = JSON.parse(document.querySelector('textarea').value)

        // Make sure that the data is in the correct format
        for (let person of people) {
          if (!('back' in person)) {
            person.back = false
          }
        }
        document.querySelector('textarea').value = JSON.stringify(people)

        count_manifestants()
      }

      count_manifestants = function() {
        let forward = 0
        let backward = 0
        for (const person of people) {
          if (person.back) {
            backward++
          } else {
            forward++
          }
        }
        document.querySelector('#manifestants').textContent = `${forward} - ${backward} = ${forward-backward}`
      }
    }


    let compt = new p5(comptage, 'comptage')

    document.querySelector('button#rewind').addEventListener('click', compt.backward)
    document.querySelector('button#pause').addEventListener('click', compt.pause)
    document.querySelector('button#play').addEventListener('click', compt.forward)
    document.querySelector('button#import').addEventListener('click', compt.import)
    // document.querySelector('button#zoom').addEventListener('click', compt.set_zoom)
    for (const input of document.querySelectorAll('input[type="number"]')) {
      input.addEventListener('input', compt.set_zoom)
    }
    document.querySelector('input#zoom_cs').addEventListener('input', compt.set_canvas_size)
    document.querySelector('button#back').addEventListener('click', compt.label_back)
  </script>
</body>

</html>